library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;

entity elabora is 
	port(clk,start: in std_logic;
	din: in std_logic_vector(15 downto 0);
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic );
end elabora;

architecture beh of elabora is

type stati is (idle,dec, store0,store1, store01,addsub);
signal S: stati:=idle;
signal op: std_logic_vector(2 downto 0);
signal r0,r1: std_logic_vector(15 downto 0);
signal writer0,writer1,op_en: std_logic;
signal conta: integer range 0 to 1;
begin
	
	process(clk)
	begin
		if clk'event and clk='0' then
			case S is
				when idle =>  if start = '1' then  
					               S<= dec;
				              else S<= idle;
					          end if;
			    when dec =>
				    case op is
					  when "000" => S<=store0;
					  when "001" => S<=store1;
					  when "010" => S<=store01;
					  when "011" => S<= idle;
					  when others => S<= addsub;
					end case;
				when store0 => S<= idle;
				when store1 => S<= idle;
				when store01 => S<= store1;
				when addsub => if conta=1 then 
					              S<= idle;
				               else S<= addsub;
							   end if;
				when others => S<= idle;
			 end case;
		end if;
	end process;
	
	process(S)
	begin
		case S is
			when idle => writer0<='0';
			             writer1<='0';
						 op_en<='0';
			when dec =>	 writer0<='0';
			             writer1<='0';
						 op_en<='0';
			when store0 => 
			             writer0<='1';
			             writer1<='0';
						 op_en<='0';
			
			when store1 => 
			             writer0<='0';
			             writer1<='1';
						 op_en<='0';
		    when store01 => 
			             writer0<='1';
			             writer1<='0';
						 op_en<='0';
		    when addsub => 
			             writer0<='0';
			             writer1<='0';
						 op_en<='1';
		    when others =>
			             writer0<='0';
			             writer1<='0';
						 op_en<='1';
		end case;
	end process;
	
	process(clk) 
	variable t: std_logic_vector(15 downto 0);
	begin
		
		if clk'event and clk='0' then
			if start ='1' then
				op <= din(2 downto 0);
				conta<= 0;
			end if;
			
			if writer0 = '1' then
				r0<= din;
				--store r0 
				end if;
			if writer1 = '1' then
				r1<= din;						--store r1
			end if;
			if op_en ='1' then 
				if conta<1 then
					conta<= conta+1;
				else case op is	
					when "100" => T:= r0+r1;	 -- add r0
								  r0<= T;
					 when "101" => T:= r0+r1;	 -- add r1
					 				r1<= T;
					 	
					when "110" => T:= r0-r1;	 -- sub r0
								  r0<= T;
					 when "111" => T:= r0-r1;	 -- sub r1
					               r1<= T;	
					 when others => null;
				    end case;
					ris<= T;
					
				end if;
		   end if; 
		 
	
	    if writer0='1' or writer1='1' or (op_en='1' and conta=1) then 
		     fine <= '1' after 1 ps; 
		else fine<= '0' after 1 ps;
	   end if;
	end if;
  end process;
		
end beh;
					  
				
			
